type register = {
  mutable pc : int;
  mutable count : int;
  data : int array;
  mutable result : int;
}
type instr =
    LOAD of int * int
  | MOVE of int * int
  | SET of int
  | INCR
  | DECR
  | JMP of int
  | BCZR of int
  | BRZR of int * int
  | ADD of int * int * int
  | MIN of int * int * int
  | MUL of int * int * int
  | DIV of int * int * int
  | RET of int
val eval : register -> instr array -> unit
val exec : instr array -> register
