(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question06 - test          *)

module Q = Question06

let rec exp x = function
  | 0 -> 1
  | 1 -> x
  | n ->
      exp (x*x) (n/2) * (if n mod 2 = 0 then 1 else x)

let rec fill_tree inf sup q = function
  | 0 -> Q.Empty
  | n ->
      let k = (inf + sup)/2 in
	Q.Node(fill_tree inf (k-1) q (n-1),
	       k , q#getN,
	       fill_tree (k+1) sup q (n-1))

let rec print = function
  | Q.Empty -> Format.printf "Empty"
  | Q.Node(Q.Empty,k,v,Q.Empty) ->
      Format.printf "@,@[<h>Node(Empty,%d,%d,Empty)@]" k v
  | Q.Node(fg,k,v,fd) ->
      Format.printf "@,@[<v 2>Node(";
      print fg;
      Format.printf ",@;%d, %d," k v;
      print fd;
      Format.printf "@,)@]"

let main () =
  begin
    let q = new Test_frame.qSeedSizeAsk 6 1024 in
      q#beginParse;
      q#init;
      let s = q#getSize in
      let t = fill_tree 1 (1 + exp (s+1) 2) q s in
	Format.printf "@[<v 2>t =";
	print t;
	Format.printf "@]@.";
	let x = q#getKey in
	  begin
	    try
	      Format.printf "%d -> %d@." x (Q.find x t)
	    with
		Not_found -> Format.printf "%d not found@." x
	  end;
	  exit 0;
  end

let _ = main ()
