(* EPITA SPE 2010/2011      *)
(* Partiel 1 - Janvier 2011 *)
(* question08 - test        *)

module Q = Question08

let print_instr line = function
  | Q.LOAD(i,r) ->
      Format.printf "%02d\tLOAD\t%d d%d;@," line i r
  | Q.MOVE(r1,r2) ->
      Format.printf "%02d\tMOVE\td%d d%d;@," line r1 r2
  | Q.SET(r) ->
      Format.printf "%02d\tSET\td%d;@," line r
  | Q.INCR ->
      Format.printf "%02d\tINCR@," line
  | Q.DECR ->
      Format.printf "%02d\tDECR@," line
  | Q.JMP(a) ->
      Format.printf "%02d\tJMP\t%d;@," line a
  | Q.BCZR(a) ->
      Format.printf "%02d\tBCZR\t%d;@," line a
  | Q.BRZR(r,a) ->
      Format.printf "%02d\tBRZR\td%d %d;@," line r a
  | Q.ADD(r1,r2,r3) ->
      Format.printf "%02d\tADD\td%d d%d d%d;@," line r1 r2 r3
  | Q.MIN(r1,r2,r3) ->
      Format.printf "%02d\tMIN\td%d d%d d%d;@," line r1 r2 r3
  | Q.MUL(r1,r2,r3) ->
      Format.printf "%02d\tMUL\td%d d%d d%d;@," line r1 r2 r3
  | Q.DIV(r1,r2,r3) ->
      Format.printf "%02d\tDIV\td%d d%d d%d;@," line r1 r2 r3
  | Q.RET(r) ->
      Format.printf "%02d\tRET\td%d;@," line r

let print inst =
  Format.printf "@[<v>START:@,";
  Array.iteri print_instr inst;
  Format.printf "END@]@."


let fact x =
[|
  Q.LOAD	(x,0);		(* 0 *)
  Q.BRZR	(0,12);		(* 1 *)
  Q.LOAD	(1,1);		(* 2 *)
  Q.LOAD	(1,2);          (* 3 *)
  Q.MIN		(0,2,0);	(* 4 *)
  Q.SET		0;		(* 5 *)
  Q.ADD		(0,2,0);	(* 6 *)
  Q.BCZR	12;		(* 7 *)
  Q.MUL		(0,1,1);	(* 8 *)
  Q.MIN		(0,2,0);	(* 9 *)
  Q.DECR;			(* 10 *)
  Q.JMP		7;		(* 11 *)
  Q.RET		1;		(* 12 *)
|]

let main () =
  begin
    let q = new Test_frame.qInt 8 12 in
      q#beginParse;
      q#init;
      let code = fact (1+q#getN) in
	print code;
	let r = Q.exec code in
	  Format.printf "EXECUTION ... result = %d@." r.Q.result;
	exit 0
  end

let _ = main ()
